CON

which_mode = Lite#PROPGFX_NTSC

_clkmode = xtal1 + pll16x
_xinfreq = 5_000_000

KeyboardPins = 26

SPRX = 0
SPRY = 1
SPRP = 2
SPRC = 3

ballx = 0
bally = 1
ballxs= 2
ballys= 3
ballp = 4
ballt = 5
ballf = 6
balllen=7

NUMBALLS = 10

JOY_UP    = %00000000_00000001
JOY_DOWN  = %00000000_00000010
JOY_LEFT  = %00000000_00000100
JOY_RIGHT = %00000000_00001000

JOY_FIRE  = %00000000_00100000

JOYDIRAND = %00000000_00001111
  
VAR
  long  stack[256]

  long  ioControl[2]

  word  balls[NUMBALLS*BALLLEN]

  long  mysptr
  long  frame
  long  T0

  long  txtx,txty

'  byte  filebuf[512]

  long  heroframe
  long  heroflip
  long  herofall
  long  herofalldir
  long  shieldx
  long  shieldw
  long  shieldy

  long  newballtimer
  long  newballcount
  
  long  PropGFXInserted    

  long  pad

OBJ
  Lite     : "GFX_BINARY_Databus"
  key      : "keyboard"

PUB Main | i,ocnt

  Key.Start(KeyboardPins,KeyboardPins+1)

  repeat 5000

  PropGFXInserted:=0
  Lite.PropGFX_Start
  if(Lite.PropGFX_TestValid<>0)
    Lite.GetID
    PropGFXInserted:=Lite.RequestIDVersion

  do_demo

PUB do_demo | i,j,ocnt,x,y,sptr

'  Lite.SetC64Mode(which_mode,Lite#PROPGFX_C64_BITMAP_MODE_2BIT,lite#PROPGFX_0_3D_COGS,j,Lite#PROPGFX_C64_SPRITES)
  Lite.SetBasicMode(which_mode,Lite#PROPGFX_2BIT_BITMAP_MODE,lite#PROPGFX_0_3D_COGS,j,Lite#PROPGFX_C64_SPRITES)
  Lite.PokeWord(Lite#PROPGFX_SPRCHRPTR,$4000)
  
  Lite.SendBuf(@ik_bit,$2000+40*16,8000)
  Lite.SendBuf(@ik_pal,$1600,256)
  Lite.SendBuf(@ik_map,$1800+80*2,2000)
  Lite.SendBuf(@ik_spr_pal,$1700,256)
  Lite.SendBuf(@ik_spr,$4000,8960)

  init_balls
  heroframe:=6
  heroflip:=0
  herofall:=0
  shieldx:=116<<4
  shieldw:=24<<4
  shieldy:=192-42
  
  repeat 
    frame++
    mysptr:=@sprdata
    longfill(@sprdata,$01800180,64*4/2)
    prtman(128  ,192,heroframe,0,heroflip)

    ptr_balls

    Lite.WaitVSync
    Lite.SendBuf(@sprdata,Lite#PROPGFX_SPRITE_LIST_BASE,64*8)

    pad:=Read_GamePad
    handle_hero
    handle_balls

PUB handle_hero
  if heroframe==6 or heroframe<3
     
    if( (pad&JOYDIRAND) == JOY_LEFT+JOY_DOWN)
      heroframe:=0
      heroflip:=1
      shieldx:=116<<4
      shieldw:=4<<4
      shieldy:=192-21
    if( (pad&JOYDIRAND) == JOY_LEFT)
      heroframe:=1
      heroflip:=1
      shieldx:=116<<4
      shieldw:=4<<4
      shieldy:=192-42
    if( (pad&JOYDIRAND) == JOY_LEFT+JOY_UP)
      heroframe:=2
      heroflip:=1
      shieldx:=116<<4
      shieldw:=4<<4
      shieldy:=192-63
     
    if( (pad&JOYDIRAND) == JOY_RIGHT+JOY_DOWN)
      heroframe:=0
      heroflip:=0
      shieldx:=172<<4
      shieldw:=4<<4
      shieldy:=192-21
    if( (pad&JOYDIRAND) == JOY_RIGHT)
      heroframe:=1
      heroflip:=0
      shieldx:=172<<4
      shieldw:=4<<4
      shieldy:=192-42
    if( (pad&JOYDIRAND) == JOY_RIGHT+JOY_UP)
      heroframe:=2
      heroflip:=0
      shieldx:=172<<4
      shieldw:=4<<4
      shieldy:=192-63
     
    if( (pad&JOYDIRAND) == JOY_DOWN)
      heroframe:=0
      shieldx:=172<<4
      if heroflip
        shieldx:=116<<4
      shieldw:=4<<4
      shieldy:=192-21
    if( (pad&JOYDIRAND) == JOY_UP)
      heroframe:=2
      shieldx:=172<<4
      if heroflip
        shieldx:=116<<4
      shieldw:=4<<4
      shieldy:=192-63

  else
    if( frame & 3) == 0
      herofall++
    heroframe:=~byte[herofalldir][herofall]
    if heroframe==-1
      heroframe:=6
      herofall:=0
     
PUB init_balls | i
  repeat i from 0 to numballs-1
    balls[i*balllen+BALLT]:=0
  newballtimer:=64*4
  newballcount:=16

PUB handle_balls | i,c,bptr
  bptr:=@balls
  repeat i from 0 to NUMBALLS-1
    if word[bptr][BALLT]
      word[bptr][BALLX]+=word[bptr][BALLXS]  
      word[bptr][BALLY]+=word[bptr][BALLYS]
      if((frame&3)==(i&3))
        word[bptr][BALLYS]++
      if(word[bptr][BALLY]>192-11)
        word[bptr][BALLYS]:=-5 '4
        word[bptr][BALLY]:=192-11

      word[bptr][BALLF]:=(word[bptr][BALLX]>>6)//9
       
      if(word[bptr][BALLX]>320<<4 and word[bptr][BALLX]<$8000)
        word[bptr][BALLT]:=0
      if(word[bptr][BALLX]>$8000 and word[bptr][BALLX]<$10000-24<<4)
        word[bptr][BALLT]:=0
       
      if herofall==0
        if (~~word[bptr][BALLXS])>0
          if(word[bptr][BALLX]>shieldx and word[bptr][BALLX]<(shieldx+shieldw))
            if (word[bptr][BALLY]+16)> shieldy and (shieldy+21)>word[bptr][BALLY]
              word[bptr][BALLXS]:=-word[bptr][BALLXS]
              word[bptr][BALLX]:=shieldx
          if(word[bptr][BALLX]>(120<<4) and word[bptr][BALLX]<((120+40)<<4))
            herofall:=1
            heroframe:=4
            if heroflip and heroframe<>6
              herofalldir:=@fallbackward
            else
              herofalldir:=@fallforward
        else    
          if(word[bptr][BALLX]>shieldx and word[bptr][BALLX]<(shieldx+shieldw))
            if (word[bptr][BALLY]+16)> shieldy and (shieldy+21)>word[bptr][BALLY]
              word[bptr][BALLXS]:=-word[bptr][BALLXS]
              word[bptr][BALLX]:=shieldx+shieldw
          if(word[bptr][BALLX]>(120<<4) and word[bptr][BALLX]<((120+40)<<4))
            herofall:=1
            heroframe:=3
            if heroflip or heroframe==6
              herofalldir:=@fallforward
            else
              herofalldir:=@fallbackward
    bptr+=BALLLEN<<1

  if (newballcount)
    newballcount--
  else
    newballcount:=newballtimer
    newballtimer-=4
    if(newballtimer<64)
      newballtimer:=64
    bptr:=@balls
    repeat i from 0 to NUMBALLS-1
      if word[bptr][BALLT]==0
        if(cnt&$800)
          word[bptr][BALLX]:=-24<<4
          word[bptr][BALLXS]:=(((cnt>>12)&31)+12)
        else
          word[bptr][BALLX]:=320<<4
          word[bptr][BALLXS]:=-(((cnt>>12)&31)+12)
        balls[i*balllen+BALLY]:=((cnt>>11)&31)+192-48
        balls[i*balllen+BALLYS]:=-((cnt>>10)&3)
        c:=((cnt>>16)//7)        
        balls[i*balllen+BALLP]:=byte[@ballps][c]
        balls[i*balllen+BALLT]:=$2000+(5*14)+6+(c*9)
        balls[i*balllen+BALLF]:=0
        return
      bptr+=BALLLEN<<1
      
PUB ptr_balls | i,bptr
  bptr:=@balls
  repeat i from 0 to NUMBALLS-1
    word[mysptr][SPRX]:=word[bptr][BALLX]>>4  
    word[mysptr][SPRY]:=word[bptr][BALLY]
    word[mysptr][SPRP]:=word[bptr][BALLP]
    word[mysptr][SPRC]:=word[bptr][BALLT]+word[bptr][BALLF]
    mysptr+=8
    bptr+=BALLLEN<<1
      

pub prtman(x,y,c,p,f) | x1,y1,fc,tx,xd,tc,w,h,cc
  if c>12
    return
  w:=manw[c]
  h:=manh[c]
  cc:=manc[c]

  if f==1
    x-=~manxof[c]
  else
    x+=~manxof[c]

  y-=(h*21)
  
  xd:=24
  fc:=$2000
  if f==1
    if c==10 or c==12
      x-=24
    x+=(w-1)*24
    xd:=-24
    fc:=$6000

  tx:=x
  repeat y1 from 0 to h-1
    x:=tx
    tc:=cc
    repeat x1 from 0 to w-1
      word[mysptr][SPRX]:=x
      word[mysptr][SPRY]:=y
      word[mysptr][SPRP]:=p
      word[mysptr][SPRC]:=cc+fc
      mysptr+=8
      cc++
      x+=xd
    cc:=tc+14
    y+=21

  if mansw[c]
    y-=mansyof[c]
    cc:=mansc[c]+fc
    w:=mansw[c]
    x:=tx
    if(w==1)
      x+=xd
    else
      if(cc&$4000)
        cc-=$4000
        xd:=24
        x-=24-4    
    repeat x1 from 0 to w-1
      word[mysptr][SPRX]:=x
      word[mysptr][SPRY]:=y
      word[mysptr][SPRP]:=1
      word[mysptr][SPRC]:=cc
      mysptr+=8
      cc++
      x+=xd
    y+=mansyof[c]
    w:=manw[c]
    xd:=24
    if f==1
      x+=(w-1)*24
      xd:=-24

  fc|=$8000    
  cc:=tc
  x:=tx    
  repeat x1 from 0 to w-1
    word[mysptr][SPRX]:=x
    word[mysptr][SPRY]:=y
    word[mysptr][SPRP]:=15
    word[mysptr][SPRC]:=cc+fc
    mysptr+=8
    cc++
    x+=xd

      
   
PUB Sin(val) : retval | c,z
  c:=val
  if c&$800
    val:=$7ff-val
  retval:=word[$e000][val&$7ff]
  if c&$1000
    retval:=-retval

PUB Read_Gamepad : bits        |  i
  bits:=0
  if key.keystate($c2)
    bits|=JOY_UP
  if key.keystate($c3)
    bits|=JOY_DOWN
  if key.keystate($c0)
    bits|=JOY_LEFT
  if key.keystate($c1)
    bits|=JOY_RIGHT
  if key.keystate($f2) or key.keystate($f3) or key.keystate(" ")
    bits|=JOY_FIRE

DAT

hextab        byte      "0123456789ABCDEF"

sprdata       byte      0[64*8]

ik_pal file "IKC64.pal"
ik_map file "IKC64.map"
ik_bit file "IKC64.CB4"
ik_spr file "MYIKSPR.JCS"
ik_spr_pal file "MYIKSPR.pal"

manc          byte      0*14+ 0,0*14+ 2,0*14+ 4,0*14+ 6,0*14+ 8,0*14+10,0*14+12
              byte      3*14+ 0,3*14+ 3,3*14+ 6,3*14+ 9
              byte      5*14+ 0,5*14+ 3

manxof        byte      0,0,0,0,0,0,0
              byte      -16,-20,-24,0
              byte      -28,0

manw          byte      2,2,2,2,2,2,2
              byte      3,3,3,3
              byte      3,3

manh          byte      3,3,3,3,3,3,3
              byte      2,2,2,2
              byte      1,1

mansw         byte      1,1,1,0,0,0,2
              byte      0,0,0,0
              byte      0,0
        
mansc         byte      4*14+12,4*14+12,4*14+12,0,0,0,3*14+12
              byte      0,0,0,0
              byte      0,0

mansyof       byte      21,42,63,0,0,0,42
              byte      0,0,0,0
              byte      0,0

              byte      0 'padding

ballps        byte      1,3,4,1,1,0,5,0

fallforward   byte      0, 4, 4, 5, 5,10,12,12,12,12,12,12,12,-1
fallbackward  byte      0, 3, 3, 7, 8, 9,11,11,11,11,11,11,11,-1
         